/*****************************************************************************
*
* Atmel Corporation
*
* ̧			: g726_16.c
* ߲		: Microsoft Visual C++ 6.0
* 			: $Revision: 1.3 $
* t			: $Date: Thursday, September 23, 2004 13:21:04 UTC $
* XV		: $Author: kmeyer $
*
* xҰ		: avr@atmel.com
*
* x޲	: ATmega128/Windows PC (ANSICׂ߲̉\
*				  )
*
* pLq		: AVR336: ADPCM
*
* 			: ADPCMp24kbpsٰ݁B͉pLqԍ336:ADPCM
*				  ɑ΂⑫łB͂̕p̕ް𐶐
*				  ̂ɕKvƂ܂B
*
*				  ĳ̈ꕔSun Microsystem, Inc.ɂČ̏ɌJꂽ
*				  ނɊ܂B
*
****************************************************************************/

/*
 * ̿ ނSun Microsystems, Inc.̐iŖ̎gpɑ΂ċĂ
 * ܂Bgp҂͑㉿Ȃɂ̿ ނ𕡎ʂ܂͕ύXł܂B
 *
 * Sun̿ ނ͐݌vAsꐫA̖ړIɑ΂KA܂͎Agp@
 * Ɩ̐isNۏ؂܂߂āAǂ̎̕ۏ؂SȂA󂻂̂܂܂Œ
 * ܂B
 *
 * Sun̿ ނ͂̎gpACAύX܂͋ɉ鉇ɑ΂
 * Sun Microsystems, Inc.̈ꕔɉĂǂȐӖȂSxȂŒ񋟂
 * B
 *
 * Sun Microsystems, Inc.͂̿ĳ܂͂̉ꂩ̕ɂĒ쌠A
 * ̔閧A܂͉ꂩ̓̐NQɊւđSӔCȂł傤B
 *
 * ႦSun̂悤ȑQ̉\̐iĂƂĂASun Microsystems,
 * Inc.͂ǂȎꂽ◘vA܂͑̓ʂŁAԐړIŊKRIȑQ
 * ɂāAx̋`Ȃł傤
 *
 * Sun Microsystems, Inc.
 * 2550 Garcia Avenue
 * Mountain View, California  94043
 */

/*
 * g726_24.c
 *
 * :
 *
 * g726_24_encoder(), g726_24_decoder()
 *
 * ٰ݂͋͂ɕύXꂽITU-T G.726 24kbps ADPCMZ@̎琬
 * ܂B
 *
 */
#include "g72x.h"

/*
 * č\ꂽړxWWΐ傫lɑ΂G.726_24ꊄ蓖
 */
static short _dqlntab[8] = {-2048, 135, 273, 373, 373, 273, 135, -2048};

/* ړxW{̑ΐɑ΂G.726_24ꊄ蓖 */
static short _witab[8] = {-128, 960, 4384, 18624, 18624, 4384, 960, -128};

/*
 * ZԕςvZAĐMÎ~(sϏ)ǂ̎w^邽
 * ɔrꂽl̑gɑ΂G.726_24ꊄ蓖
 */
static short _fitab[8] = {0, 0x200, 0x400, 0xE00, 0xE00, 0x400, 0x200, 0};

static short qtab_726_24[3] = {8, 218, 331};

/*
 * g726_24_encoder()
 *
 * 16ޯĒPCMAA-lawA-law͎̓𕄍Čʂ5ޯADPCMԂ܂
 * ͕̏ꍇ-1Ԃ܂B
 */
int
g726_24_encoder(
	int sl,
	int in_coding,
	struct g72x_state *state_ptr)
{
	short se, sez;		/* ACCUM */
	short d;			/* SUBTA */
	short y;			/* MIX */
	short sr;			/* ADDB */
	short dqsez;		/* ADDC */
	short dq, i;

	switch (in_coding) {						/* ͎14ޯPCMɒ */
	case AUDIO_ENCODING_ALAW:
		sl = alaw2linear((unsigned char) sl) >> 2;
		break;
	case AUDIO_ENCODING_ULAW:
		sl = ulaw2linear((unsigned char) sl) >> 2;
		break;
	case AUDIO_ENCODING_LINEAR:
		sl >>= 2;								/* ͈14ޯĐ */
		break;
	default:
		return (-1);
	}
	se = predictor(&sez, state_ptr);			/* se=\M */
	d = sl - se;								/* d=\ */
	/* \d̗ʎq */
	y = step_size(state_ptr);					/* KʎqiK */
	i = quantize(d, y, qtab_726_24, 3);			/* i=ADPCM */
	dq = reconstruct(i & 4, _dqlntab[i], y);	/* ʎq */
	sr = se + dq;								/* č\M */
	dqsez = sr + sez - se;						/* dqsez=ɗ\ */
	update(3, y, _witab[i], _fitab[i], dq, sr, dqsez, state_ptr);
	return (i);
}

/*
 * g726_24_decoder()
 *
 * 3ޯ CCITT G.726_24 ADPCM𕜍Čʂ̒PCMAA-lawA܂̓-law
 * lԂ܂B
 * o͕m̏ꍇ-1Ԃ܂B
 */
int
g726_24_decoder(
	int i,
	int out_coding,
	struct g72x_state *state_ptr)
{
	short sez, se;		/* ACCUM */
	short y;			/* MIX */
	short sr;			/* ADDB */
	short dq;
	short dqsez;

	i &= 0x07;										/* ޯĂ𓾂邽߂ɎՕ */
	se = predictor(&sez, state_ptr);				/* se=\M */
	y = step_size(state_ptr);						/* KʎqiK */
	dq = reconstruct(i & 0x04, _dqlntab[i], y);		/* ʎq\ */
	sr = se + dq;									/* č\M */
	dqsez = sr - se + sez;							/* ɗ\ */
	update(3, y, _witab[i], _fitab[i], dq, sr, dqsez, state_ptr);
	switch (out_coding) {
	case AUDIO_ENCODING_ALAW:
		return (tandem_adjust_alaw(sr, se, y, i, 4, qtab_726_24));
	case AUDIO_ENCODING_ULAW:
		return (tandem_adjust_ulaw(sr, se, y, i, 4, qtab_726_24));
	case AUDIO_ENCODING_LINEAR:
		return (sr << 2);							/* sr14ޯĊ͈͂̂ŉ */
	default:
		return (-1);
	}
}
